
import java.io.*;



public class Parms {

  private static String nextLine(BufferedReader in) throws Exception  {
    String r = in.readLine();

    while (r.matches("(\\s*#.*)|(\\s*$)")) {
      r = in.readLine() ;
    }
    return r ;
  }

  String meshFilename ;
  public static double [] cameraPosition  = new double[3] ;
  double [] cameraLookAt    = new double[3] ;
  double [] cameraUp        = new double[3] ;
  double cameraXLimit ;
  double cameraFocal ;
  int screenW ;
  int screenH ;
  public static double ambientI;
  public static double sourceI;
  public static double[] sourceCoord      = new double[4] ;
  double[] material         = new double[4] ;

  public Parms(String filename) throws Exception {

    InputStream is = getClass().getResourceAsStream(filename);
    //BufferedReader in = new BufferedReader(new FileReader(filename));
    BufferedReader in = new BufferedReader(new InputStreamReader(is));
    
    meshFilename = nextLine(in);

    String r = nextLine(in);
    String [] sar = r.split("\\s+");
    cameraPosition[0] = new Double(sar[0]).doubleValue();
    cameraPosition[1] = new Double(sar[1]).doubleValue();
    cameraPosition[2] = new Double(sar[2]).doubleValue();

    r = nextLine(in);
    sar = r.split("\\s+");
    cameraLookAt[0] = new Double(sar[0]).doubleValue();
    cameraLookAt[1] = new Double(sar[1]).doubleValue();
    cameraLookAt[2] = new Double(sar[2]).doubleValue();

    r = nextLine(in);
    sar = r.split("\\s+");
    cameraUp[0] = new Double(sar[0]).doubleValue();
    cameraUp[1] = new Double(sar[1]).doubleValue();
    cameraUp[2] = new Double(sar[2]).doubleValue();

    r = nextLine(in);
    cameraXLimit = new Double(r).doubleValue();

    r = nextLine(in);
    cameraFocal = new Double(r).doubleValue();

    r = nextLine(in);
    sar = r.split("\\s+");
    screenW = new Integer(sar[0]).intValue();
    screenH = new Integer(sar[1]).intValue();
 
    r = nextLine(in);
    ambientI = new Double(r).doubleValue();

    r = nextLine(in);
    sar = r.split ("\\s+");
    for (int i = 0; i < sourceCoord.length; i++) {
    	sourceCoord[i] = new Double(sar[i]).doubleValue();	
    }
    sourceI = new Double(sar[4]).doubleValue();
 
    r = nextLine(in);
    sar = r.split ("\\s+");
    for (int i = 0; i < material.length; i++) {
    	material[i] = new Double(sar[i]).doubleValue();	
    }
 

  }

  public String    getMeshFileName   () { return meshFilename ; }
  public double [] getCameraPosition () { return cameraPosition ; }   
  public double [] getCameraLookAt   () { return cameraLookAt   ; }   
  public double [] getCameraUp       () { return cameraUp       ; }   
  public double    getCameraXLimit   () { return cameraXLimit   ; }   
  public double    getCameraFocal    () { return cameraFocal    ; }   
  public int       getScreenW        () { return screenW        ; }   
  public int       getScreenH        () { return screenH        ; }   
  public double    getAmbientI       () { return ambientI       ; }
  public double    getSourceI        () { return sourceI        ; }
  public double[]  getSourceCoord    () { return sourceCoord    ; }
  public double[]  getMaterial       () { return material       ; }

}
