
import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Graphics;
import java.util.*;

import javax.swing.UIManager;

public class Renderer3D extends Applet implements Runnable{
	
  private static GraphicsWrapper gi;
  
  private static Parms p;
  
  public static boolean withTextures = true;
  public static boolean withLight = true;
  public static boolean meshRot = true;
  public static boolean spotRot = false;
  
  public static ImageComponent drawComp = null;
  
  public static Renderer3D r3d;
  
  private static ControlPanel control;
  
  public void init(){
    
    System.setProperty("awt.image.redrawrate","1");
    
    // Get the native look and feel class name
    String nativeLF = UIManager.getSystemLookAndFeelClassName();
    
    // Install the look and feel
    try {
        UIManager.setLookAndFeel(nativeLF);
    } catch (Exception e) {
    } 
    
    r3d = this;
    
    control = new ControlPanel();
    control.setSize(100,200);
    
    try {
      p = new Parms("input_files/example2.in") ;
      MeshData md = new MeshData(p.getMeshFileName()) ;
    } catch (Exception e) {
      e.printStackTrace();
    }

    gi  = new GraphicsWrapper(400,320,1) ;
    
    setLayout(new BorderLayout());

    add("Center", drawComp);
    add("East", control);
    
    //control.repaint();

  }
  
  public void start(){
    //this.setSize(200,200);
    drawComp.paintBlack();
    try {
      new Thread(this).start();
    } catch (Exception e){
      e.printStackTrace();
    }
  }
  
  public void repaintDrawComp(){
    drawComp.repaint();
  }
  
  public void run(){
    
    long time;
    for (int i=0; i>=0; i++){
      try {
        time = System.currentTimeMillis();
        drawFrame();
        time = 90-(System.currentTimeMillis()- time);
        if (time > 0) Thread.sleep(time);
        //else System.out.println(time);
        
        if ((!spotRot && meshRot) || (!meshRot && spotRot)) rotateLightAroundY(0.06);
        if (meshRot) rotateCameraAroundY(0.06);
      } catch (Exception e){
        e.printStackTrace();
      }
    }
 
  }
  
  public void stop() {
    
  }
  
  public void update(Graphics g){
    paint(g);
  }

  
  public static void rotateCameraAroundY(double angle){
    double x = p.cameraPosition[0];
    double z = p.cameraPosition[2];
    double newX = x*Math.cos(angle)-z*Math.sin(angle);
    double newZ = x*Math.sin(angle)+z*Math.cos(angle);
    p.cameraPosition[0]=newX;
    p.cameraPosition[2]=newZ;
    
  }
  
  public static void rotateLightAroundY(double angle){
    
    double x = p.sourceCoord[0];
    double z = p.sourceCoord[2];
    double newX = x*Math.cos(angle)-z*Math.sin(angle);
    double newZ = x*Math.sin(angle)+z*Math.cos(angle);
    p.sourceCoord[0]=newX;
    p.sourceCoord[2]=newZ;
    
  }
  
  public static void rotateCameraAroundX(double angle){
    double y = p.cameraPosition[1];
    double z = p.cameraPosition[2];
    double newY = y*Math.cos(angle)-z*Math.sin(angle);
    double newZ = y*Math.sin(angle)+z*Math.cos(angle);
    p.cameraPosition[1]=newY;
    p.cameraPosition[2]=newZ;
    if (newZ<0) p.cameraUp[1] = -p.cameraUp[1];
  }
  
  public static void rotateCameraAroundZ(double angle){
    double x = p.cameraPosition[0];
    double y = p.cameraPosition[1];
    double newX = x*Math.cos(angle)-y*Math.sin(angle);
    double newY = x*Math.sin(angle)+y*Math.cos(angle);
    p.cameraPosition[0]=newX;
    p.cameraPosition[1]=newY;
  }
  

  public static void drawFrame() throws Exception {
    //System.out.println("OFF\n# TestAll Start");

    
    //MeshData md = new MeshData(p.getMeshFileName()) ;
    MeshData md = MeshData.md;
    

    //MeshData md = new MeshData("input_files/cube_multi_color.off") ;
    //Parms p = new Parms("input_files/cube_multi_color.off") ;
    //MeshData md = new MeshData(p.getMeshFileName()) ;
    int h = p.getScreenH();
    int w = p.getScreenW();
    //GraphicsWrapper gi = new GraphicsWrapper(w,h,1) ;
    Zbuffer zB = new Zbuffer(w,h);
    gi.clearBuffer() ;
    
    double vertices[] = new double[md.getVertices ().length];//(double[])md.getVertices ().clone();
    int    faces   [] = new int[md.getFaces ().length];//(int[])md.getFaces    ().clone();
    double colors  [] = new double[md.getColors ().length];//(double[])md.getColors   ().clone();
    double normals [] = new double[md.getNormals().length];//(double[])md.getNormals  ().clone();
    

    
    System.arraycopy(md.getVertices (), 0, vertices, 0, md.getVertices ().length);
    System.arraycopy(md.getColors(), 0, colors, 0, colors.length);
    System.arraycopy(md.getNormals(), 0, normals, 0, normals.length);
    System.arraycopy(md.getFaces(), 0, faces, 0, faces.length);
    

    

   //System.out.println("Vertices");
   //for (int i = 0 ; i < vertices.length / 3 ; i++ ){
   //  System.out.println(
   //    ( (vertices[ 3 * i + 0 ] + 1.4) / 3 )+ " " +
   //    ( (vertices[ 3 * i + 1 ] + 1.4) / 3 )+ " " +
   //    ( (vertices[ 3 * i + 2 ] + 1.4) / 3 ));
   //}
   // 
   // System.out.println("colors");
   // for (int i = 0 ; i < vertices.length / 3 ; i++ ){
   //   System.out.println(
   // 	        colors[ 3 * i + 0 ] + " " +
   // 	        colors[ 3 * i + 1 ] + " " +
   // 	        colors[ 3 * i + 2 ] );  	 
   // }
   // 
   // System.out.println("faces");
   //     for (int i = 0 ; i < faces.length / 3 ; i++){
   //     System.out.println("3 " +
   //         faces[ 3 * i + 0 ] + " " +
   //         faces[ 3 * i + 1 ] + " " +
   //         faces[ 3 * i + 2 ]);
   // }
    
    // Light Bloc:
    if (withLight) {
      double 	ambientI   = p.getAmbientI       () ;
      double   srcI      = p.getSourceI        () ;
      double[] srcCrd    = p.getSourceCoord    () ;
      double[] material  = p.getMaterial       () ;
      double [] cameraPosition = p.getCameraPosition () ;
      Lighting lighter = new Lighting();
      lighter.addAmbientLight(ambientI);


      lighter.addLightPoint(srcCrd[0], srcCrd[1],srcCrd[2], srcCrd[3],srcI);
      for (int i = 0 ; i < vertices.length / 3 ; i++) {
        double [] newColor = lighter.applyLights(
            vertices[ 3 * i + 0 ],  vertices[ 3 * i + 1 ], vertices[ 3 * i + 2 ],
            normals[ 3 * i + 0 ],  normals[ 3 * i + 1 ], normals[ 3 * i + 2 ],
            material[0], material[1], material[2], material[3], 
            cameraPosition[0], cameraPosition[1], cameraPosition[2], 
            colors[ 3 * i + 0 ],  colors[ 3 * i + 1 ], colors[ 3 * i + 2 ]);

    ///    System.out.println("Transforming: " +
    ///        colors[ 3 * i + 0 ] +", " +
    ///        colors[ 3 * i + 1 ] +", " +
    ///        colors[ 3 * i + 2 ] + "  To   " +
    ///        Math.max(0.0, Math.min(1.0, newColor[ 0 ]))+", " +
    ///        Math.max(0.0, Math.min(1.0, newColor[ 1 ]))+", " +
    ///        Math.max(0.0, Math.min(1.0, newColor[ 2 ])));
        colors[ 3 * i + 0 ] = Math.max(0.0, Math.min(1.0, newColor[ 0 ])) ;
        colors[ 3 * i + 1 ] = Math.max(0.0, Math.min(1.0, newColor[ 1 ])) ;
        colors[ 3 * i + 2 ] = Math.max(0.0, Math.min(1.0, newColor[ 2 ])) ;

      }
  
    }

    
    vertices = Transform.camera2Raw2D(Transform.projection(Transform.world2Camera(vertices , p),p),p);

    // Rendu fil de fer
    {
    	int nbVertices = vertices.length/3;
    	Raw2D.Attributed2D[] attVertices = new Raw2D.Attributed2D[nbVertices];
    	List line = new LinkedList();
    	Iterator it;
    	
      // transform les vertices en attributed data
      for (int i = 0; i < nbVertices; i++) {
        double[] myAtt = new double[4]; // on stockera color (3 doubles) et z (1 double)

        //System.out.println("Adding: " +
        //    colors[ 3 * i + 0 ] +", " +
        //    colors[ 3 * i + 1 ] +", " +
        //    colors[ 3 * i + 2 ] ); 
        for (int j = 0; j < 3; j++) {
          myAtt[j] = withTextures?colors[3*i+j]:1.;
        }
        myAtt[3] = vertices[3*i+2]; //z
        attVertices[i] = new Raw2D.Attributed2D((int)vertices[3*i], (int)vertices[3*i+1] , myAtt ) ;
      }			
    	
      if (!withTextures){
      	// en suivant la topologie des faces dessine les aretes des triangles
      	for (int i = 0; i < faces.length; i=i+3) {
      		for (int j = 0; j < 3; j++) {
      			line.addAll(Raw2D.bresenhamAndInterpol(attVertices[faces[i+j]],attVertices[faces[i+(j+1)%3]]));  		    
      		}
      	}
      	
      	it = line.iterator();
      
      	while (it.hasNext()){
      		Raw2D.Attributed2D point = (Raw2D.Attributed2D) it.next();
          if ( 0 <= point.x && point.x < w && 0 <= point.y && point.y < h) {
            if (zB.seePixel(point.x, point.y, point.attr[3])) {
              gi.setPixel(point.x, point.y, point.attr[0], point.attr[1], point.attr[2]);
            }
          }
      	}

      	
      } else {

        gi.clearBuffer() ;
        zB.clearBuffer();
        
	    // Rendu surfacique
	    {
	    	List surf = new LinkedList();
	    	
	    	// en suivant la topologie des faces dessine les triangles
	    	for (int i = 0; i < faces.length; i=i+3) {
	    	//	for (int j = 0; j < 3; j++) {
	    	//	gi.setPixel(attVertices[faces[i+j]].x, attVertices[faces[i+j]].y, attVertices[faces[i+j]].attr[0], 
	    	//			attVertices[faces[i+j]].attr[1], attVertices[faces[i+j]].attr[2]);
	    	//		}		
	    		    surf.addAll(Raw2D.fillTriangleWithRectangle(attVertices[faces[i+0]],attVertices[faces[i+1]],attVertices[faces[i+2]]));
	    		}	
	    	
	    	it = surf.iterator();
	        
	    	while (it.hasNext()){
	    		Raw2D.Attributed2D point = (Raw2D.Attributed2D) it.next();
          if ( 0 <= point.x && point.x < w && 0 <= point.y && point.y < h) {
            if (zB.seePixel(point.x, point.y, point.attr[3])) {
              gi.setPixel(point.x, point.y, 
                  point.attr[0]>1?1:point.attr[0], 
                  point.attr[1]>1?1:point.attr[1], 
                  point.attr[2]>1?1:point.attr[2]);
            }
          }
	    	}

	    }
        

      }
      gi.swapBuffers() ;
  	    //gi.destroy() ;
  	    //System.exit(0);
    }
  }

  

  public static void main(String[] args) {

    try {
      

        //init() ;
        //playLoop();

    } catch (Exception e) {
      System.out.println("EXCEPTION: " + e) ;
      e.printStackTrace() ;
    }

  }
}

